// Library First
//     0.1.0
// £2012/1/30
// ʱ䣺2012/1/25 20:51
//   ߣfy
// ˵    ɿCԵĺ⡣
//           ģʵһ򵥵ַ͡

#include <stdio.h>
#include <string.h>
#include "fstring.h"

// Form gcc,LGPL
char *strndup (const char *s, size_t n)
{
    char *result;
    size_t len = strlen (s);

    if (n < len)
        len = n;

    result = (char *) malloc (len + 1);
    if (!result)
        return 0;

    result[len] = '\0';
    return (char *) memcpy (result, s, len);
}

fstring tofstring(const char start[],int len)
{
    fstring retval;
    retval.s = (char*)start;
    retval.len = len;
    return retval;
}

fstring newfstring(const char start[],int len)
{
    fstring retval;
    // Ÿchar*β \0
    retval.s = strndup(start,len);
    retval.len = len;
    retval.notlink = true;
    return retval;
}

//#define printfstrln(s) printfstr(s); putchar('\n')

void printfstr(fstring s)
{
    int i;
    for (i=0;i<s.len;i++) putchar(s.s[i]);
}

// һfstringвһchar
int fstrfindch(char ch,fstring s)
{
    int i;

    for (i=0;i<s.len;i++) {
        if (ch==s.s[i]) return i;
    }
    return -1;
}

// fstring s2вfstring s1
int fstrinstr(fstring *s1,fstring *s2)
{
    int i,ret;
    char ch = s1->s[0];

    for (i=0;i<s2->len;i++) {
        if (ch==s2->s[i]) {
            if (s1->len>s2->len-i) return -1;
            ret = i;
            if (strncmp(s1->s,&s2->s[i],s1->len)==0) return ret;
        }
    }
    return -1;
}

fstringlist* newfstrlist()
{
    fstringlist *ret;

    ret = malloc(sizeof(fstringlist));
    if (!ret) {
        printf("ڴʧܣ\n");
        return NULL;
    }
    memset(ret,0,sizeof(fstringlist));
    return ret;
}

void freefstringlist(fstringlist* strlist)
{
    int i;
    for (i=0;i<strlist->num;i++) {
        if (strlist->s[i].notlink)
            free(strlist->s[i].s);
    }
    free(strlist->s);
    free(strlist);
}

void printfstrlist(fstringlist* strlist)
{
    int i;
    for (i=0;i<strlist->num;i++)
        printfstrln(strlist->s[i]); 
}

/* Щڿдڴǳȶ
#define partfstr(s,partsign) _partfstr(s,partsign,2)
fstringlist* _partfstr(fstring s,fstring partsign,int defnum)
{
int i,curn=0;
char *curc=s.s;
fstring *tmp;
fstringlist *ret;

ret = malloc(sizeof(fstringlist));
if (!ret) {
printf("ڴʧܣ\n");
exit(0);
}
ret->num = defnum;

ret->s = malloc(defnum*sizeof(fstring));
memset(ret->s,0,defnum*sizeof(fstring));

for (i=0;i<s.len;i++) {
if (fstrfindch(s.s[i],partsign)!=-1||i==s.len-1) {
if (curn+1>defnum) {
tmp = ret->s;
if (!realloc(tmp,(curn+1)*sizeof(fstring))) {
printf("ڴʧܣ\n");
tmp = malloc((curn+1)*sizeof(fstring));
if (!tmp) {
printf("ڴʧˣ\n");
exit(0);
}
memcpy(tmp,ret->s,curn*sizeof(fstring));
free(ret->s);
ret->s = tmp;
}
memset(&ret->s[curn],0,sizeof(fstring));
}
ret->s[curn].s = curc;
ret->s[curn].len = &s.s[i]-curc;
printfstrln(ret->s[curn]);
curc = &s.s[i+1];
curn++;
}
}
ret->num = curn+1;
return ret;
}*/

fstringlist* partfstr(fstring s,fstring partsign)
{
    int i,curn=0;
    char *curc=s.s;
    fstringlist *ret;

    ret = malloc(sizeof(fstringlist));
    if (!ret) {
        printf("ڴʧܣ\n");
        exit(0);
    }

    // ͳƣڴ
    // +1ԭһָĩβҪռһ
    for (i=0;i<s.len;i++) {
        if (fstrfindch(s.s[i],partsign)!=-1) curn++;
    }

    ret->s = malloc((curn+1)*sizeof(fstring));
    if (!ret->s) {
        printf("ڴʧܣ\n");
        exit(0);
    }
    memset(ret->s,0,(curn+1)*sizeof(fstring));

    curn = 0;
    for (i=0;i<s.len;i++) {
        if (fstrfindch(s.s[i],partsign)!=-1||i==s.len-1) {
            ret->s[curn].s = curc;
            ret->s[curn].len = &s.s[i]-curc;
            printfstrln(ret->s[curn]);
            curc = &s.s[i+1];
            curn++;
        }
    }
    ret->num = curn;
    return ret;
}

int partfstr_tolist(fstringlist *strlst,fstring s,fstring partsign)
{
    int i,curn=0;
    fstring *tmp;
    char *curc=s.s;
    static int realbufnum;

    // ͳƣռ䲻ڴ
    // +1ԭһָĩβҪռһ
    for (i=0;i<s.len;i++) {
        if (fstrfindch(s.s[i],partsign)!=-1) curn++;
    }

    // Ϊ״η
    if (!strlst->s) {
        strlst->s = malloc((curn+1)*sizeof(fstring));
        if (!strlst->s) {
            printf("ڴʧܣ\n");
            return false;
        }
        memset(strlst->s,0,(curn+1)*sizeof(fstring));
        realbufnum = curn+1;
    // ǣڴ棬ĳ
    } else {
        if (curn+1>realbufnum) {
            tmp = strlst->s;
            if (!realloc(tmp,(curn+1)*sizeof(fstring))) {
                printf("ڴʧܣٴ룡\n");
                tmp = malloc((curn+1)*sizeof(fstring));
                if (!tmp) {
                    printf("ڴʧܣǿ˳\n");
                    exit(0);
                }
                memcpy(tmp,strlst->s,curn*sizeof(fstring));
                free(strlst->s);
            }
            memset(&tmp[curn],0,sizeof(fstring));
            strlst->s = tmp;
            realbufnum = curn+1;
        }
    }

    curn = 0;
    for (i=0;i<s.len;i++) {
        if (fstrfindch(s.s[i],partsign)!=-1||i==s.len-1) {
            strlst->s[curn].s = curc;
            strlst->s[curn].len = &s.s[i]-curc;
            curc = &s.s[i+1];
            curn++;
        }
    }
    strlst->num = curn;
    return true;
}
